#!/usr/bin/python

import sys
import os
import subprocess

# arguments:
# [1] operation -- "add", "update", or "delete" based on whether or not
#     the address is being added to, modified, or  deleted  from  OpenVPN's
#     internal routing table.
# [2] address  --  The  address being learned or unlearned.  This can be
#     an IPv4 address such as "198.162.10.14", an IPv4 subnet such as
#     "198.162.10.0/24", or an ethernet MAC address (when --dev tap is being
#     used) such as "00:FF:01:02:03:04".
# [3] common name -- The common name on the certificate associated with
#     the client linked to this address.  Only  present  for  "add"  or
#     "update" operations, not "delete".

if len(sys.argv) < 3:
    print "bad argument list: {}".format(str(sys.argv[1:]))
    sys.exit(0)

dev = os.environ['dev']
action = sys.argv[1]
addr = sys.argv[2]
if len(sys.argv) > 3:
    cn = sys.argv[3]

if action == "add" or action == "update":
    print "[-] Add addr {} for {}".format(addr, cn)
    cmd = ['sudo', '/sbin/ip', 'route', 'repl', "{}".format(addr), 'dev', dev]
    subprocess.call(cmd)
elif action == "delete":
    print "[-] Del addr {}".format(addr)
    cmd =['sudo', '/sbin/ip', 'route', 'del', "{}".format(addr)]
    subprocess.call(cmd)
